﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    [StructLayout(LayoutKind.Sequential)]
    public struct Variant
    {
        public ushort vt;
        public ushort wReserved1;
        public ushort wReserved2;
        public ushort wReserved3;
        public IntPtr data01;
        public IntPtr data02;
    }

    class Program
    {
        [DllImport("oleaut32.dll", PreserveSig = true)]
        private static extern int VariantClear(IntPtr pObject);

        unsafe static int _varSize = sizeof(Variant);

        static unsafe void Main(string[] args)
        {
            int i = 0;
            while (true)
            {
                TestHandleWithLeak();

                i++;

                if (i > 1000)
                {
                    GC.Collect();
                    GC.Collect();
                    i = 0;
                }
            }
        }

        private unsafe static void TestHandleWitInt()
        {
            IntPtr pAlloc = Marshal.AllocHGlobal(_varSize);
            {
                Marshal.GetNativeVariantForObject(5, pAlloc);
                Marshal.FreeHGlobal(pAlloc);
            }
        }

        private unsafe static void TestHandleWithLeak()
        {
            object obj = new object();

            IntPtr pAlloc = Marshal.AllocHGlobal(_varSize);
            {
                Marshal.GetNativeVariantForObject(obj, pAlloc);
                Marshal.FreeHGlobal(pAlloc);
            }
        }

        private unsafe static void TestHandleWithoutLeak()
        {
            object obj = new object();

            IntPtr pAlloc = Marshal.AllocHGlobal(_varSize);
            {
                Marshal.GetNativeVariantForObject(obj, pAlloc);

                VariantClear(pAlloc);
                Marshal.FreeHGlobal(pAlloc);
            }
        }
    }
}
